/******************************************************************************
*******************************************************************************

	Bubble Fight EX
	relminator
	http://rel.betterwebber.com


	Boiler class


*******************************************************************************
******************************************************************************/

#include <nds.h>
#include <vector>
#include "Vector2df32.h"

#include "EntityContainer.h"
#include "StarFighter.h"
#include "Explosion.h"

#ifndef BOILER_H
#define BOILER_H

//------------------------------------------------------------------------------
//	Boiler Enemy
//------------------------------------------------------------------------------
class Boiler 
{

public:
	friend class BoilerContainer;
	
	Boiler();
	~Boiler();
	void Update();
	
private:
	s32		x;
	s32		y;
	s32		Dx;
	s32		Dy;
	s32		Sy;
	s32		Angle;
	int 	Radius;
	int		Frame;
	int 	Counter;
	bool	Active;
	int 	Hp;
	
	EN_DRAW_MODE DrawMode;
	
	
};

//------------------------------------------------------------------------------
//	Boiler Container
//------------------------------------------------------------------------------
class BoilerContainer : public EntityContainer
{	

public:

	BoilerContainer();
    ~BoilerContainer();
	void Init(int Palette, glImage* const Sprites );
    virtual void UpdateEntities();
	virtual void DrawEntities();
	virtual bool Collide( StarFighter &Star );
	virtual void KillAllEntities();
	virtual int NumEntities() 
	{
		return numEntities;
	}
	
	void Spawn( int _x, s32 _speed, int _radius );
	
private:
	int numEntities;
	
	glImage *Images;
	int ColorTable;
	
	std::vector<Boiler> Boilers;
	
	
};


#endif // BOILER_H
