/******************************************************************************
*******************************************************************************

	Bubble Fight EX
	relminator
	http://rel.betterwebber.com


	Cancer class


*******************************************************************************
******************************************************************************/

#include <nds.h>
#include <vector>
#include "Vector2df32.h"

#include "EntityContainer.h"
#include "StarFighter.h"
#include "Explosion.h"


#ifndef CANCER_H
#define CANCER_H

//------------------------------------------------------------------------------
//	Cancer Enemy
//------------------------------------------------------------------------------
class Cancer 
{

public:
	friend class CancerContainer;
	
	Cancer();
	~Cancer();
	void Update();
	
private:
	s32		x;
	s32		y;
	s32		Dx;
	s32		Dy;
	int		Frame;
	int 	Counter;
	bool	Active;
	int 	Hp;
	
	EN_DRAW_MODE DrawMode;
	
};

//------------------------------------------------------------------------------
//	Cancer Container
//------------------------------------------------------------------------------
class CancerContainer : public EntityContainer
{	

public:

	CancerContainer();
    ~CancerContainer();
    void Init( int Palette, glImage* const Sprites );
    virtual void UpdateEntities();
	virtual void DrawEntities();
	virtual bool Collide( StarFighter &Star );
	virtual void KillAllEntities();
	void Spawn( int _x, int _y );
	
	inline int NumEntities() 
	{
		return numEntities;
	}
	
private:
	int numEntities;
	
	glImage *Images;
	int ColorTable;
	
	std::vector<Cancer> Cancers;
	
	
};

#endif // CANCER_H
