/******************************************************************************
*******************************************************************************

	Bubble Fight EX
	relminator
	http://rel.phatcode.net


	Millipede class


*******************************************************************************
******************************************************************************/

#include <nds.h>
#include <vector>
#include "Vector2df32.h"

#include "Spline.h"
#include "EntityContainer.h"
#include "StarFighter.h"
#include "Explosion.h"

#include "BossEntity.h"

#ifndef MILLIPEDE_H
#define MILLIPEDE_H

#define MILLIPEDE_MAX_SEGMENTS 128

//------------------------------------------------------------------------------
//	Millipede Enemy
//------------------------------------------------------------------------------
class Millipede  : public BossEntity
{

public:
	
	Millipede();
	~Millipede();
	
	virtual void Init( int Palette, glImage* const Sprites );
	virtual void Update();
	virtual void Draw();
	virtual bool Collide( StarFighter &Star );
	virtual void Spawn();
	
	void LoadPath( int _sx, int _sy, int _ex, int _ey );
	
	
	virtual s32 GetX()
	{
		return x;
	}
	
	virtual s32 GetY()
	{
		return y;
	}
	
	virtual bool IsAlive()
	{
		return Alive;
	}
	
	virtual bool IsActive()
	{
		return Active;
	}
	
	virtual int GetDestroyedCounter()
	{
		return DestroyedCounter;
	}
	
	
	virtual void SetX( int _x )
	{
		x = _x;
	}
	
	virtual void SetY( int _y )
	{
		y = _y;
	}
	
	virtual void DecDestroyedCounter()
	{
		DestroyedCounter--;
	}
	
	virtual void SetDestroyedCounter( int val )
	{
		DestroyedCounter = val;
	}
	
	virtual void SetAlive( bool alive )
	{
		Alive = alive;
	}
	
	virtual void SetActive( bool active )
	{
		Active = active;
	}
		
private:
	s32		x;
	s32		y;
	bool	Alive;
	bool	Active;
	
	int		DestroyedCounter;
	
	int		Frame;
	int 	Counter;
	int 	Hp;
	
	int ColorTable;
	
	EN_DRAW_MODE DrawMode;
	GL_FLIP_MODE FlipMode;
	
	Spline Path;
	
	Vector2df32  LastPoint;
	Vector2df32  Segments[MILLIPEDE_MAX_SEGMENTS];
	
	
	glImage *Images;
	
	void ClosePath();
	
	void ResetSegments()
	{
		for( int i = 0; i < MILLIPEDE_MAX_SEGMENTS; i++ )
		{
			Segments[i].x = inttof32(400);
			Segments[i].y = inttof32(96);
		}
	}
	
};


#endif // MILLIPEDE_H
