/******************************************************************************
*******************************************************************************

	Bubble Fight EX
	relminator
	http://rel.betterwebber.com


	Rotator class


*******************************************************************************
******************************************************************************/

#include <nds.h>
#include <vector>
#include "Vector2df32.h"

#include "Spline.h"
#include "EntityContainer.h"
#include "StarFighter.h"
#include "Explosion.h"

#ifndef ROTATOR_H
#define ROTATOR_H

//------------------------------------------------------------------------------
//	Rotator Enemy
//------------------------------------------------------------------------------
class Rotator 
{

public:
	friend class RotatorContainer;
	
	Rotator();
	~Rotator();
	void Update();
	
private:
	s32		x;
	s32		y;
	int		Frame;
	int 	Counter;
	bool	Active;
	int 	Hp;
	
	EN_DRAW_MODE DrawMode;
	
	Spline Path;

	void LoadPath( int _sx, int _sy, int _ex, int _ey, s32 _time, bool _flip );
	
};

//------------------------------------------------------------------------------
//	Rotator Container
//------------------------------------------------------------------------------
class RotatorContainer : public EntityContainer
{	

public:

	RotatorContainer();
    ~RotatorContainer();
	void Init(int Palette, glImage* const Sprites );
    virtual void UpdateEntities();
	virtual void DrawEntities();
	virtual bool Collide( StarFighter &Star );
	virtual void KillAllEntities();
	virtual int NumEntities() 
	{
		return numEntities;
	}
	
	void Spawn( s32 _time, bool _flip, int _frame );
	
private:
	int numEntities;
	
	glImage *Images;
	int ColorTable;
	
	std::vector<Rotator> Rotators;
	
	
};

#endif // ROTATOR_H
