/******************************************************************************
*******************************************************************************

	Bubble Fight EX
	relminator
	http://rel.betterwebber.com


	Skullo class


*******************************************************************************
******************************************************************************/

#include <nds.h>
#include <vector>
#include "Vector2df32.h"

#include "Spline.h"
#include "EntityContainer.h"
#include "StarFighter.h"
#include "Explosion.h"

#ifndef SKULLO_H
#define SKULLO_H

//------------------------------------------------------------------------------
//	Skullo Enemy
//------------------------------------------------------------------------------
class Skullo {

public:
	friend class SkulloContainer;
	
	Skullo();
	~Skullo();
	void Update();
	
private:
	s32		x;
	s32		y;
	int		Frame;
	int 	Counter;
	bool	Active;
	int 	Hp;
	
	EN_DRAW_MODE DrawMode;
	
	Spline Path;

	void LoadPath( int _sx, int _sy, int _ex, int _ey, s32 _time, bool _flip );
	
};

//------------------------------------------------------------------------------
//	Skullo Container
//------------------------------------------------------------------------------
class SkulloContainer : public EntityContainer
{	

public:

	SkulloContainer();
    ~SkulloContainer();
	void Init(int Palette, glImage* const Sprites );
    virtual void UpdateEntities();
	virtual void DrawEntities();
	virtual bool Collide( StarFighter &Star );
	virtual void KillAllEntities();
	virtual int NumEntities() 
	{
		return numEntities;
	}
	
	void Spawn( s32 _time, bool _flip );
	
private:
	int numEntities;
	
	glImage *Images;
	int ColorTable;
	
	std::vector<Skullo> Skullos;
	
	
};

#endif // SKULLO_H
